﻿using System.Diagnostics.CodeAnalysis;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.DependencyInjection;
using RestApiTemplate.Application.Dtos.Settings;

namespace RestApiTemplate.CrossCutting.AppSettings
{
    /// <summary>
    /// Responsável por injetar as propriedades do appSettings
    /// </summary>
    [ExcludeFromCodeCoverage]
    public static class AppSettingsConfiguration
    {
        public static void AddAppSettingsConfiguration(this IServiceCollection services, IConfiguration configuration)
        {
             services.AddSingleton(service => configuration.GetSection("Logging").Get<LoggingSettings>());
        }
    }
}
