﻿using System.Diagnostics.CodeAnalysis;
using AutoMapper;

using Microsoft.Extensions.DependencyInjection;

using Rchlo.Omni.Common.Adapter;
using Rchlo.Omni.Common.Adapter.AutoMapper;

using RestApiTemplate.Application.Adapters;

namespace RestApiTemplate.CrossCutting.Automapper
{
    /// <summary>
    /// Configurações de automapper
    /// </summary>
    [ExcludeFromCodeCoverage]
    public static class AutomapperConfiguration
    {
        public static void AddAutomapperConfiguration(this IServiceCollection services)
        {
            services.AddSingleton<IAdapter, AutomapperAdapter>();
            services.AddSingleton(new MapperConfiguration(cfg => { cfg.ConfigureAutomapper(); }).CreateMapper());
        }
    }
}
