﻿using System;
using System.Data;
using System.Diagnostics.CodeAnalysis;
using Microsoft.EntityFrameworkCore;
using Microsoft.Extensions.DependencyInjection;

using Npgsql;

using RestApiTemplate.Infrastructure.Data;

namespace RestApiTemplate.CrossCutting.Database
{
    /// <summary>
    /// Classe responsável por realizar a configuração DBContext com a base de dados utilizando o EF
    /// </summary>
    /// <remarks>
    ///     Só foi implementado a conexão com o Postgres para demonstração.
    ///     Caso seja necessário comunicar com outra base de dados, 
    ///     aqui é o local que devemos configurar e realizar a implementação dos métodos
    /// </remarks>
    [ExcludeFromCodeCoverage]
    public static class DatabaseConfiguration
    {
        public static void AddEFPostgresConfiguration(this IServiceCollection services, string connection)
        {
            services.AddDbContext<ApplicationDbContext>(options => options.UseNpgsql(connection))
                    .AddUnitOfWork<ApplicationDbContext>();
        }

        public static void AddEFSqlConfiguration(this IServiceCollection services, DbContext dbContext, string connection)
        {
            throw new NotImplementedException();
        }

        public static void AddEFMySqlConfiguration(this IServiceCollection services, DbContext dbContext, string connection)
        {
            throw new NotImplementedException();
        }

        public static void AddDapperPostgresConfiguration(this IServiceCollection services, string connectionString)
        {
            services.AddTransient<IDbConnection>((sp) => new NpgsqlConnection(connectionString));
        }
    }
}
