﻿using AutoMapper;
using Microsoft.EntityFrameworkCore;
using RestApiTemplate.Application.Dtos.Request;
using RestApiTemplate.Application.Dtos.Response;
using RestApiTemplate.Domain.Entities;

namespace RestApiTemplate.Application.Adapters
{
    /// <summary>
    /// Configuração de conversão de objetos anêmicos de entrada e saída em objetos de domínio.
    /// </summary>
    public static class AutomapperResolver
    {
        public static void ConfigureAutomapper(this IMapperConfigurationExpression cfg)
        {
            cfg?.CreateMap<ExampleRequest, Example>()
                .ConstructUsing(o => new Example(o.Name, o.Price, o.UserLoggedId))
                .ReverseMap();

            cfg?.CreateMap<ExampleResponse, Example>()
                .ReverseMap();

            cfg?.CreateMap<PagedList<Example>, PagedList<ExampleResponse>>().ReverseMap();
        }
    }

}


