﻿using Destructurama.Attributed;
using Rchlo.Omni.Common.Bases.Dto;

namespace RestApiTemplate.Application.Dtos.Request
{
    /// <summary>
    /// Modelo anêmico para requisição, para inibir/substituir o valor de alguma propriedade sensível nos logs, utilize a notation [LogMasked] na propriedade desejada. 
    /// Mais exemplos de mascaras no arquivo readme.
    /// </summary>
    public class ExampleRequest : RequestBase
    {
        public string Name { get; set; }
        public decimal Price { get; set; }
        [LogMasked(Text = "REMOVED")]
        public string Password { get; set; }
    }
}
