﻿using System;

using Rchlo.Omni.Common.Bases.Domain;
using Rchlo.Omni.Common.Enums;

namespace RestApiTemplate.Domain.Entities
{
    /// <summary>
    /// O Entidade não deve ser apenas uma estrutura de dados (modelo anêmico), ele deve ser responsável por alterações
    /// de estado de suas propriedades e capturar o conhecimento do domínio.
    /// </summary>
    public class Example : EntityBase
    {
        public string Name { get; private set; }
        public decimal Price { get; private set; }
        public bool IsEnabled { get; private set; }

        private Example(Guid userCreatorId) : base(userCreatorId){}

        public Example(string name, decimal price, Guid userCreatorId) :
            this(userCreatorId) 
        {
            Name = name;
            Price = price;
            IsEnabled = false;
        }

        internal void Enable(Guid userUpdaterId)
        {
            IsEnabled = true;

            Audit(EEntityStatus.Updated, userUpdaterId);
        }
    }
}
