﻿using Microsoft.EntityFrameworkCore;
using RestApiTemplate.Domain.Entities;
using RestApiTemplate.Infrastructure.Data.Mappings;
using System.Diagnostics.CodeAnalysis;

namespace RestApiTemplate.Infrastructure.Data
{
    [ExcludeFromCodeCoverage]
    public class ApplicationDbContext : DbContext
    {
        public ApplicationDbContext(DbContextOptions<ApplicationDbContext> options) : base(options){}

        public DbSet<Example> Example { get; set; }

        protected override void OnModelCreating(ModelBuilder modelBuilder)
        {
            modelBuilder.HasDefaultSchema("public")
               .ApplyConfiguration(new ExampleMapping());

            base.OnModelCreating(modelBuilder);
        }
    }
}
