﻿#region using
using System;
using System.IO;
using System.Reflection;

using AutoMapper;

using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.DependencyInjection;

using Rchlo.Omni.Common.Adapter;
using Rchlo.Omni.Common.Adapter.AutoMapper;

using RestApiTemplate.Application.Adapters;
#endregion

namespace RestApiTemplate.Tests.Application.Services
{
    public class BaseTest
    {
        #region Variables
        public IServiceProvider ServiceProvider { get; set; }
        #endregion

        #region Constructor
        public BaseTest()
        {
            ServiceProvider = BuilderServiceProvider();
        }
        #endregion

        #region Private Methods
        private IServiceProvider BuilderServiceProvider()
        {
            var services = new ServiceCollection();

            services.AddSingleton(new MapperConfiguration(cfg => { cfg.ConfigureAutomapper(); }).CreateMapper());

            services.AddSingleton<IAdapter, AutomapperAdapter>();

            return services.BuildServiceProvider();
        }
        #endregion
    }
}
